# Welcome to SQLRAG

SQLRAG allows users to query databases using natural language and receive results as SQL code and beautiful visualizations. Powered by Large Language Models (LLMs), SQLRAG supports both OpenAI models and open-source alternatives from GPT4All. Additionally, Redis caching is employed for optimized performance, and users can choose between CPU and GPU processing for open-source models.

### About SQLRAG


SQLRAG is a Python package that lets users query their databases using simple natural language prompts. SQLRAG translates these prompts into SQL, executes the queries, and returns results as SQL code, data, and visualizations using either Matplotlib or Chart.js. It supports both open-source LLMs from GPT4All and paid models like OpenAI, giving users flexibility in model choice.

Redis caching is used to speed up responses for repeated queries, and users can opt for GPU processing with open-source models for faster execution.

Key Features:

- **Natural Language Queries**: Input your queries in plain language, and SQLRAG will convert them into SQL statements.
- **Data Visualization**: Generate charts using Python's Matplotlib or JavaScript's Chart.js.
- **Model Flexibility**: Supports both OpenAI models and open-source alternatives like GPT4All.
- **Redis Caching**: Improves response times for repeated queries by caching previous results.
- **Supports CPU and GPU**: Open-source models can run on both CPU and GPU, providing performance flexibility.

Developed and maintained by **Abdulla Ansari**, a Senior Software Engineer at Mindfire Digital LLP, SQLRAG reflects deep expertise in software engineering and AI-driven technologies. Mindfire Solutions is a leading provider of software and IT services, specializing in the development and delivery of complex projects for enhancing business performance and innovation.
